/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateComponent type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateComponent{}

// WhatsAppTemplateComponent struct for WhatsAppTemplateComponent
type WhatsAppTemplateComponent struct {
	Type WhatsAppTemplateComponentType `json:"type"`
	Format *WhatsAppTemplateHeaderFormat `json:"format,omitempty"`
	Text *string `json:"text,omitempty"`
	Example *WhatsAppTemplateComponentExample `json:"example,omitempty"`
	Buttons []WhatsAppTemplateButton `json:"buttons,omitempty"`
	Cards []WhatsAppTemplateCard `json:"cards,omitempty"`
}

// NewWhatsAppTemplateComponent instantiates a new WhatsAppTemplateComponent object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateComponent(type_ WhatsAppTemplateComponentType) *WhatsAppTemplateComponent {
	this := WhatsAppTemplateComponent{}
	this.Type = type_
	return &this
}

// NewWhatsAppTemplateComponentWithDefaults instantiates a new WhatsAppTemplateComponent object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateComponentWithDefaults() *WhatsAppTemplateComponent {
	this := WhatsAppTemplateComponent{}
	return &this
}

// GetType returns the Type field value
func (o *WhatsAppTemplateComponent) GetType() WhatsAppTemplateComponentType {
	if o == nil {
		var ret WhatsAppTemplateComponentType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponent) GetTypeOk() (*WhatsAppTemplateComponentType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *WhatsAppTemplateComponent) SetType(v WhatsAppTemplateComponentType) {
	o.Type = v
}

// GetFormat returns the Format field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponent) GetFormat() WhatsAppTemplateHeaderFormat {
	if o == nil || IsNil(o.Format) {
		var ret WhatsAppTemplateHeaderFormat
		return ret
	}
	return *o.Format
}

// GetFormatOk returns a tuple with the Format field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponent) GetFormatOk() (*WhatsAppTemplateHeaderFormat, bool) {
	if o == nil || IsNil(o.Format) {
		return nil, false
	}
	return o.Format, true
}

// HasFormat returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponent) HasFormat() bool {
	if o != nil && !IsNil(o.Format) {
		return true
	}

	return false
}

// SetFormat gets a reference to the given WhatsAppTemplateHeaderFormat and assigns it to the Format field.
func (o *WhatsAppTemplateComponent) SetFormat(v WhatsAppTemplateHeaderFormat) {
	o.Format = &v
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponent) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponent) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponent) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *WhatsAppTemplateComponent) SetText(v string) {
	o.Text = &v
}

// GetExample returns the Example field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponent) GetExample() WhatsAppTemplateComponentExample {
	if o == nil || IsNil(o.Example) {
		var ret WhatsAppTemplateComponentExample
		return ret
	}
	return *o.Example
}

// GetExampleOk returns a tuple with the Example field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponent) GetExampleOk() (*WhatsAppTemplateComponentExample, bool) {
	if o == nil || IsNil(o.Example) {
		return nil, false
	}
	return o.Example, true
}

// HasExample returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponent) HasExample() bool {
	if o != nil && !IsNil(o.Example) {
		return true
	}

	return false
}

// SetExample gets a reference to the given WhatsAppTemplateComponentExample and assigns it to the Example field.
func (o *WhatsAppTemplateComponent) SetExample(v WhatsAppTemplateComponentExample) {
	o.Example = &v
}

// GetButtons returns the Buttons field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponent) GetButtons() []WhatsAppTemplateButton {
	if o == nil || IsNil(o.Buttons) {
		var ret []WhatsAppTemplateButton
		return ret
	}
	return o.Buttons
}

// GetButtonsOk returns a tuple with the Buttons field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponent) GetButtonsOk() ([]WhatsAppTemplateButton, bool) {
	if o == nil || IsNil(o.Buttons) {
		return nil, false
	}
	return o.Buttons, true
}

// HasButtons returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponent) HasButtons() bool {
	if o != nil && !IsNil(o.Buttons) {
		return true
	}

	return false
}

// SetButtons gets a reference to the given []WhatsAppTemplateButton and assigns it to the Buttons field.
func (o *WhatsAppTemplateComponent) SetButtons(v []WhatsAppTemplateButton) {
	o.Buttons = v
}

// GetCards returns the Cards field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponent) GetCards() []WhatsAppTemplateCard {
	if o == nil || IsNil(o.Cards) {
		var ret []WhatsAppTemplateCard
		return ret
	}
	return o.Cards
}

// GetCardsOk returns a tuple with the Cards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponent) GetCardsOk() ([]WhatsAppTemplateCard, bool) {
	if o == nil || IsNil(o.Cards) {
		return nil, false
	}
	return o.Cards, true
}

// HasCards returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponent) HasCards() bool {
	if o != nil && !IsNil(o.Cards) {
		return true
	}

	return false
}

// SetCards gets a reference to the given []WhatsAppTemplateCard and assigns it to the Cards field.
func (o *WhatsAppTemplateComponent) SetCards(v []WhatsAppTemplateCard) {
	o.Cards = v
}

func (o WhatsAppTemplateComponent) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateComponent) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.Format) {
		toSerialize["format"] = o.Format
	}
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	if !IsNil(o.Example) {
		toSerialize["example"] = o.Example
	}
	if !IsNil(o.Buttons) {
		toSerialize["buttons"] = o.Buttons
	}
	if !IsNil(o.Cards) {
		toSerialize["cards"] = o.Cards
	}
	return toSerialize, nil
}

type NullableWhatsAppTemplateComponent struct {
	value *WhatsAppTemplateComponent
	isSet bool
}

func (v NullableWhatsAppTemplateComponent) Get() *WhatsAppTemplateComponent {
	return v.value
}

func (v *NullableWhatsAppTemplateComponent) Set(val *WhatsAppTemplateComponent) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateComponent) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateComponent) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateComponent(val *WhatsAppTemplateComponent) *NullableWhatsAppTemplateComponent {
	return &NullableWhatsAppTemplateComponent{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateComponent) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateComponent) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


